package clarion.options;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * <ul>
 * <li> General overview.
 * <ul>
 * <li> summary of this class <br>
 * This class is to provide a frame to show sample or explanation how a task-
 * Specific option in CLARION is implemented.
 * <ol>
 * <li> public void showSample( String text ): show the sample or explanation of a
*  task-specific opiton is implemented.
 * </ol>
 * </ul>
 * <li> Role in the CLARION model <br>
 * This class is part of GUI embedded in one selection frame.
 * <li> Usage of this class. <br>
 * It is instantiated inside a <em>SelectionTemplate</em> object.
 * </ul>
 * @author Xi Zhang
 *
 */

public class SeeSampleFrame extends JFrame {

 JFrame superFrame;
 JScrollPane areaScrollPane;
 JTextArea showArea = new JTextArea( 30, 60 );
 JButton returnButton = new JButton( "return" );


 public SeeSampleFrame( JFrame superFrame )
 {
    this.superFrame = superFrame;
    this.setName( "SAMPLE CODES" );
    setSize( 500, 400 );
    this.getContentPane().setLayout( new BorderLayout());
    areaScrollPane = new JScrollPane(showArea);
    areaScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    areaScrollPane.setPreferredSize(new Dimension(250, 250));
    areaScrollPane.setBorder( BorderFactory.createLineBorder(Color.black) );

    returnButton.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(ActionEvent e) {
            setEnabled( false );
            setVisible( false );
         }
    });
    this.getContentPane().add( areaScrollPane, BorderLayout.CENTER );
    this.getContentPane().add( returnButton, BorderLayout.SOUTH );
 }

 /** show some sample or explanation of a task-specific opiton is implemented.
  * @param text the text to show on this frame. */
  public void showSample( String text )
 {
    showArea.setText( text );
 }

}
