package clarion.options.nacs;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import clarion.system.*;
import clarion.options.*;
import clarion.options.transfer.*;

/**
 * <ul>
 * <li> General overview.
 * <ul>
 * <li> summary of this class <br>
 * This class extends the <tt>SelectionTemplate</tt> class and is the class
 * for configuration of option relevant to the coordination of ACS and NACS.
 *
 * <li> summary of the important methods <br>
 * <ol>
 * <li> public void initGui(): initialize the GUI components in this frame.
 * </ol>
 * </ul>
 * <li> Usage of this class. <br>
 * It is part of GUI of overall structure configuration and it is instantiated in
 * <tt>GuiNACS</tt> class.
 * </ul>
 * @author Xi Zhang
 *
 */

public class SelectionCor extends SelectionTemplate{
  JFrame superFrame;
  JLabel capLabel = new JLabel();
  JPanel corPanel = new JPanel();
  JLabel corLabel = new JLabel();
  JRadioButton[] corButtons = new JRadioButton[2]; {
     corButtons[0] = new JRadioButton();
     corButtons[1] = new JRadioButton();
  }

  // return buttons.
  JButton returnButton = new JButton();

  public SelectionCor( JFrame superFrame, int width, int height, TransferManager manager )
 {
    super( superFrame, width, height, manager );
    initGui();
 }

 /* initialize the GUI components in this frame. */
 public void initGui()
 {
    //final int COR = 0, GKS = 1, ITER = 2, RTH = 3;
    final int COR = 0;
    options = manager.getOptions( Global.NACS, Global.NACS_COR, 0, 0, 0, 0 );
    Border BORDER = BorderFactory.createLineBorder(Color.black);
    Color COLOR = SystemColor.activeCaption;
    String[] onOffTexts = { "ON", "OFF" };
    setSize( width, height );
    this.getContentPane().setLayout(null);
    // caption
    initLabel( capLabel, "OPTIONS OF COORDINATING ACS AND NACS", new java.awt.Font("Dialog", 1, 14),
               SwingConstants.CENTER, new Rectangle(16, 2, 327, 26));
    // coordinate
    initPanel( corPanel, BORDER, null, new Rectangle(10, 30, 336, 70));
    String[] corTexts = {"action-directed reasoning", "user defined"};
    Rectangle[] corRects = {new Rectangle(12, 28, 164, 17), new Rectangle(12, 48, 140, 17)};
    initButtonBlock( corPanel,corLabel,"Option for coordinating ACS/NACS",new Rectangle(8, 4, 197, 17),
                     corButtons, corTexts, corRects, options[COR] );

    // return buttons.
    initReturnButton( returnButton, "RETURN", new Rectangle(250, 366, 80, 28));
    corPanel.add(corLabel, null);

    this.getContentPane().add(corPanel, null);
    this.getContentPane().add(capLabel, null);
    this.getContentPane().add(returnButton, null);
  }
}
