package clarion.options.supervise;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import clarion.system.*;
import clarion.options.*;
import clarion.options.transfer.*;

/**
 * <ul>
 * <li> General overview.
 * <ul>
 * <li> summary of this class <br>
 * This class extends the <tt>SelectionTemplate</tt> class and is the class
 * for configuration of options relevant to the overall structure of Supervisory
 * subsystem by GUI. It contains the options such as  selection of  Motivaional
 * Subsystem (MS) and Meta-Cognitive System (MCS).
 *
 * <li> summary of the important methods <br>
 * <ol>
 * <li> public void initGui(): initialize the GUI components in this frame.
 * </ol>
 * </ul>
 * <li> Usage of this class. <br>
 * It is part of GUI of overall Supervisory Subsystem configuration and it is
 * instantiated in <tt>GuiSupervisory</tt> class.
 * </ul>
 * @author Xi Zhang
 *
 */

public class SelectionSuperComp extends SelectionTemplate{
  JFrame superFrame;
  JLabel capLabel = new JLabel();
  JPanel compPanel = new JPanel();
  JLabel comLabel = new JLabel();
  JLabel msLabel = new JLabel();
  JRadioButton[] msButtons = new JRadioButton[2]; {
     msButtons[0] = new JRadioButton();
     msButtons[1] = new JRadioButton();
  }
  JLabel mcsLabel = new JLabel();
  JRadioButton[] mcsButtons = new JRadioButton[2]; {
     mcsButtons[0] = new JRadioButton();
     mcsButtons[1] = new JRadioButton();
  }
  JButton returnButton = new JButton();

  public SelectionSuperComp( JFrame superFrame, int width, int height, TransferManager manager )
  {
    super( superFrame, width, height, manager );
    initGui();
  }

  /** initialize the GUI components in this frame. */
  public void initGui()
  {
    final int MS = 0, MCS = 1;

    options = manager.getOptions( Global.SUPER, Global.SUPER_COMP, 0, 0, 0, 0 );
    Border BORDER = BorderFactory.createLineBorder(Color.black);
    Color COLOR = SystemColor.activeCaption;
    String[] onOffTexts = { "ON", "OFF" };
    setSize( width, height );
    this.getContentPane().setLayout(null);
    // caption
    initLabel( capLabel,"OPTIONS OF SUPERVISORY COMPONENTS",new java.awt.Font("Dialog", 1, 14),
               SwingConstants.CENTER, new Rectangle(20, 2, 340, 27));
    // component panel
    initPanel( compPanel, BORDER, null, new Rectangle(10, 40, 360, 100));
    initLabel( comLabel, "Supervisory components", new Rectangle(10, 8, 160, 17) );
    // MS
    Rectangle[] msRects = {new Rectangle(160, 34, 50, 17),new Rectangle(210, 34, 55, 17)};
    initButtonBlock( compPanel, msLabel, "Motivational Subsystem",new Rectangle(10, 34, 140, 17),
                     msButtons, onOffTexts, msRects, options[MS] );
    // MCS
    Rectangle[] mcsRects = {new Rectangle(180, 64, 50, 17),new Rectangle(230, 64, 55, 17)};
    initButtonBlock( compPanel, mcsLabel, "Meta-Cognitive Subsystem", new Rectangle(10, 64, 160, 17),
                     mcsButtons, onOffTexts, mcsRects, options[MCS] );
    // RETTURN BUTTONS.
    initReturnButton( returnButton, "RETURN", new Rectangle(270, 160, 100, 28));
    compPanel.add(comLabel, null);
    this.getContentPane().add(capLabel, null);
    this.getContentPane().add(compPanel, null);
    this.getContentPane().add(returnButton, null);
  }
}
