package clarion.options.taskspec;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import clarion.system.*;
import clarion.options.*;
import clarion.options.transfer.*;

/**
 * <ul>
 * <li> General overview.
 * <ul>
 * <li> summary of this class <br>
 * This class extends the <tt>SelectionTemplate</tt> class and is the class
 * for configuration of options relevant to Task-Specific by GUI.
 * It contains the options such as how the simulation data is recorded.
 *
 * <li> summary of the important methods <br>
 * <ol>
 * <li> public void initGui(): initialize the GUI components in this frame.
 * </ol>
 * </ul>
 * <li> Usage of this class. <br>
 * It is part of GUI of Task-Specific configuration and it is instantiated in
 * <tt>GuiTask</tt> class.
 * </ul>
 * @author Xi Zhang
 *
 */

public class SelectionTaskSpec extends SelectionTemplate {
 JFrame superFrame;

 JLabel capLabel = new JLabel();
 JPanel panel = new JPanel();
 // record information
 JLabel recordLabel = new JLabel();
 JCheckBox[] recordBoxes = new JCheckBox[5];{
    for( int i = 0; i < 5; i++ )
         recordBoxes[i] = new JCheckBox();
 }
 // return buttons.
 JButton returnButton = new JButton();

 public SelectionTaskSpec( JFrame superFrame, int width, int height, TransferManager manager )
  {
    super( superFrame, width, height, manager );
    initGui();
  }

 /** initialize the GUI components in this frame. */
 public void initGui()
 {
    final int RECORD = 0;

    options = manager.getOptions( Global.TS, 0, 0, 0, 0, 0 );
    Border BORDER = BorderFactory.createLineBorder(Color.black);
    Color COLOR = SystemColor.activeCaption;
    setSize( width, height );
    this.getContentPane().setLayout(null);
    // caption.
    initLabel( capLabel, "TASK SPECIFIC OPTIONS", new java.awt.Font("Dialog", 1, 14),
               SwingConstants.CENTER, new Rectangle(50, 0, 200, 26) );
    initPanel( panel, BORDER, null, new Rectangle(10, 30, 300, 200));
    // the information to record.
    String[] recordBoxTexts = { "input (state)", "output (aciton)", "new state", "reinforcement",
                                "response time" };
    Rectangle[] recordBoxRects = { new Rectangle(10, 30, 150, 17), new Rectangle(10, 50, 150, 17),
                                  new Rectangle(10, 70, 150, 17), new Rectangle(10, 90, 150, 17),
                                  new Rectangle(10, 110, 150, 17)
                                };
    initCheckBoxBlock( panel, recordLabel, "the information to record", new Rectangle(10, 10, 200, 17),
                       recordBoxes, recordBoxTexts, recordBoxRects, options[RECORD] );
    // return buttons.
    initReturnButton( returnButton, "RETURN", new Rectangle(200, 240, 100, 25));
    // add components.
    this.getContentPane().add( capLabel, null );
    this.getContentPane().add( panel, null );
    this.getContentPane().add( returnButton, null );
  }
}
